/** @license Digigov v0.1.0
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
import _extends from "@babel/runtime/helpers/extends";
import defaultParserInterface from 'astql/utils/defaultParserInterface';
import pkg from 'php-parser/package.json';
var ID = 'php-parser';
var defaultOptions = {
  parser: {
    extractDoc: true
  },
  ast: {
    withPositions: true
  }
};
export default _extends({}, defaultParserInterface, {
  id: ID,
  displayName: ID,
  version: pkg.version,
  homepage: pkg.homepage,
  locationProps: new Set(['loc']),
  typeProps: new Set(['kind']),
  loadParser: function loadParser(callback) {
    require('astql/utils/multiple-require')(['php-parser'], callback);
  },
  parse: function parse(Engine, code) {
    var parser = new Engine(defaultOptions);
    return parser.parseCode(code, '');
  },
  getNodeName: function getNodeName(node) {
    return node.kind;
  },
  nodeToRange: function nodeToRange(node) {
    if (node.loc && node.loc.start && node.loc.end) {
      return [node.loc.start.offset, node.loc.end.offset];
    }
  },
  opensByDefault: function opensByDefault(node, key) {
    return key === 'body' || key === 'what' || key === 'items';
  }
});